/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Indexes;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Keys;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records.InvoiceReclamoRecord;

import java.sql.Timestamp;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class InvoiceReclamo extends TableImpl<InvoiceReclamoRecord> {

    private static final long serialVersionUID = 1242488724;

    /**
     * The reference instance of <code>INVOICE_RECLAMO</code>
     */
    public static final InvoiceReclamo INVOICE_RECLAMO = new InvoiceReclamo();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<InvoiceReclamoRecord> getRecordType() {
        return InvoiceReclamoRecord.class;
    }

    /**
     * The column <code>INVOICE_RECLAMO.ID_INVOICE_RECLAMO</code>.
     */
    public final TableField<InvoiceReclamoRecord, Integer> ID_INVOICE_RECLAMO = createField("ID_INVOICE_RECLAMO", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.ID_DSP</code>.
     */
    public final TableField<InvoiceReclamoRecord, String> ID_DSP = createField("ID_DSP", org.jooq.impl.SQLDataType.VARCHAR(100).nullable(false), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.COMMERCIAL_OFFER</code>.
     */
    public final TableField<InvoiceReclamoRecord, String> COMMERCIAL_OFFER = createField("COMMERCIAL_OFFER", org.jooq.impl.SQLDataType.VARCHAR(100).nullable(false), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.COUNTRY</code>.
     */
    public final TableField<InvoiceReclamoRecord, String> COUNTRY = createField("COUNTRY", org.jooq.impl.SQLDataType.VARCHAR(3).nullable(false), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.DATA_INSERIMENTO</code>.
     */
    public final TableField<InvoiceReclamoRecord, Timestamp> DATA_INSERIMENTO = createField("DATA_INSERIMENTO", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaultValue(org.jooq.impl.DSL.field("CURRENT_TIMESTAMP", org.jooq.impl.SQLDataType.TIMESTAMP)), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.DATA_ULTIMA_MODIFICA</code>.
     */
    public final TableField<InvoiceReclamoRecord, Timestamp> DATA_ULTIMA_MODIFICA = createField("DATA_ULTIMA_MODIFICA", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>INVOICE_RECLAMO.UTENTE</code>.
     */
    public final TableField<InvoiceReclamoRecord, String> UTENTE = createField("UTENTE", org.jooq.impl.SQLDataType.VARCHAR(32).nullable(false), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.PERIOD</code>.
     */
    public final TableField<InvoiceReclamoRecord, Integer> PERIOD = createField("PERIOD", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.PERIOD_TYPE</code>.
     */
    public final TableField<InvoiceReclamoRecord, String> PERIOD_TYPE = createField("PERIOD_TYPE", org.jooq.impl.SQLDataType.VARCHAR(10).nullable(false), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.YEAR</code>.
     */
    public final TableField<InvoiceReclamoRecord, Integer> YEAR = createField("YEAR", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.STATO</code>.
     */
    public final TableField<InvoiceReclamoRecord, Integer> STATO = createField("STATO", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.ID_DSR</code>.
     */
    public final TableField<InvoiceReclamoRecord, String> ID_DSR = createField("ID_DSR", org.jooq.impl.SQLDataType.VARCHAR(512), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.FILE_LOCATION</code>.
     */
    public final TableField<InvoiceReclamoRecord, String> FILE_LOCATION = createField("FILE_LOCATION", org.jooq.impl.SQLDataType.VARCHAR(512), this, "");

    /**
     * The column <code>INVOICE_RECLAMO.FILE_NAME</code>.
     */
    public final TableField<InvoiceReclamoRecord, String> FILE_NAME = createField("FILE_NAME", org.jooq.impl.SQLDataType.VARCHAR(512), this, "");

    /**
     * Create a <code>INVOICE_RECLAMO</code> table reference
     */
    public InvoiceReclamo() {
        this(DSL.name("INVOICE_RECLAMO"), null);
    }

    /**
     * Create an aliased <code>INVOICE_RECLAMO</code> table reference
     */
    public InvoiceReclamo(String alias) {
        this(DSL.name(alias), INVOICE_RECLAMO);
    }

    /**
     * Create an aliased <code>INVOICE_RECLAMO</code> table reference
     */
    public InvoiceReclamo(Name alias) {
        this(alias, INVOICE_RECLAMO);
    }

    private InvoiceReclamo(Name alias, Table<InvoiceReclamoRecord> aliased) {
        this(alias, aliased, null);
    }

    private InvoiceReclamo(Name alias, Table<InvoiceReclamoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> InvoiceReclamo(Table<O> child, ForeignKey<O, InvoiceReclamoRecord> key) {
        super(child, key, INVOICE_RECLAMO);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.INVOICE_RECLAMO_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<InvoiceReclamoRecord, Integer> getIdentity() {
        return Keys.IDENTITY_INVOICE_RECLAMO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<InvoiceReclamoRecord> getPrimaryKey() {
        return Keys.KEY_INVOICE_RECLAMO_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<InvoiceReclamoRecord>> getKeys() {
        return Arrays.<UniqueKey<InvoiceReclamoRecord>>asList(Keys.KEY_INVOICE_RECLAMO_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceReclamo as(String alias) {
        return new InvoiceReclamo(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceReclamo as(Name alias) {
        return new InvoiceReclamo(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public InvoiceReclamo rename(String name) {
        return new InvoiceReclamo(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public InvoiceReclamo rename(Name name) {
        return new InvoiceReclamo(name, null);
    }
}
